# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 David Planella <david.planella@ubuntu.com>
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from gi.repository import Gtk
from qreator_lib.helpers import get_data_file
from qreator_lib.i18n import _


class QRCodeURLGtk(object):
    def __init__(self, qr_code_update_func):
        self.qr_code_update_func = qr_code_update_func
        builder = Gtk.Builder()

        builder.add_from_file(
            get_data_file('ui', '%s.ui' % ('QrCodeURL',)))
        self.grid = builder.get_object('qr_code_url')
        
        self.entry = builder.get_object('entryURL')
        self.combobox = builder.get_object('comboboxtextProtocol')

        # Initialize placeholder text (we need to do that because due to
        # a Glade bug they are otherwise not marked as translatable)
        self.entry.set_placeholder_text(_('[URL]'))
        self.combobox.set_active(0)
        
        self.entry.connect("changed", self.on_entryURL_changed)
        self.combobox.connect("changed", self.on_comboboxtextProtocol_changed)

    def on_activated(self):
        pass

    def update_url_qr_code(self, protocol=None, www=None):
        if not protocol:
            protocol = self.combobox.get_active_text()
        if not www:
            www = self.entry.get_text()

        if not protocol or www == '':
            return

        self.qr_code_update_func(protocol + www)

    #def on_entryURL_icon_press(self, widget, icon, mouse_button):
    #    self._clear_text_entry(widget, icon)

    def on_entryURL_changed(self, widget, data=None):
        #self._check_style(widget)
        self.update_url_qr_code(www=widget.get_text())

    def on_comboboxtextProtocol_changed(self, widget, data=None):
        self.update_url_qr_code(protocol=widget.get_active_text())
